# Define the kmod package name here.
%define	 kmod_name alsa
%define  src_name alsa-driver

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 2.6.32-220.el6.%{_target_cpu}}

Name:    %{kmod_name}-kmod
Version: 1.0.24
Release: 2%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: ALSA driver kernel modules
URL:     http://www.alsa-project.org/

BuildRequires: redhat-rpm-config
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{src_name}-%{version}.tar.bz2
Source10: kmodtool-%{kmod_name}-el6.sh

# Patches.
Patch0: alsa-1.0.24-rhel6.2-adriver.patch

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the Advanced Linux Sound Architecture (ALSA) driver modules.
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -c -T -a 0
%patch0 -p0
%{__cp} -a %{src_name}-%{version} _kmod_build_
KSRC=%{_usrsrc}/kernels/%{kversion}
pushd _kmod_build_
./configure -q --with-kernel="${KSRC}" --with-build="${KSRC}" \
    --with-redhat=yes --with-isapnp=no
popd

%build
KSRC=%{_usrsrc}/kernels/%{kversion}
pushd _kmod_build_
%{__make}
popd

%install
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} _kmod_build_/modules/*.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
MODULES_DIR=%{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}
:>kmod-%{kmod_name}.conf
for FILENAME in $MODULES_DIR/*.ko
do
    MODULE="$( echo $FILENAME | sed 's/.*\/\(.*\)\.ko/\1/' )"
    echo "override $MODULE * weak-updates/%{kmod_name}" >> kmod-%{kmod_name}.conf
done
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} _kmod_build_/{CARDS-STATUS,COPYING,FAQ,README,SUPPORTED_KERNELS,TODO,WARNING} \
    %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Tue Apr 17 2012 Philip J Perry <phil@elrepo.org> - 1.0.24-2.el6.elrepo
- Rebuild against RHEL-6.2 to avoid alt_instr fixups
  [http://elrepo.org/bugs/view.php?id=244]
- Backport code to generate override conf file automatically
- Disable hex_to_bin and vzalloc functions in adriver.h as these are now backported to RHEL-6.2
  [alsa-1.0.24-rhel6.2-adriver.patch]

* Fri Apr 29 2011 Philip J Perry <phil@elrepo.org> - 1.0.24-1.el6.elrepo
- Update to 1.0.24.

* Mon Jan 24 2011 Philip J Perry <phil@elrepo.org> - 1.0.23-1.el6.elrepo
- Initial el6 build of the kmod package.
